/*
 * Copyright 2020 Anton Trushkov
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.ksdfv.thelema.gl

// OpenGL ES 3

const val GL_READ_BUFFER = 0x0C02
const val GL_UNPACK_ROW_LENGTH = 0x0CF2
const val GL_UNPACK_SKIP_ROWS = 0x0CF3
const val GL_UNPACK_SKIP_PIXELS = 0x0CF4
const val GL_PACK_ROW_LENGTH = 0x0D02
const val GL_PACK_SKIP_ROWS = 0x0D03
const val GL_PACK_SKIP_PIXELS = 0x0D04
const val GL_COLOR = 0x1800
const val GL_DEPTH = 0x1801
const val GL_STENCIL = 0x1802
const val GL_RED = 0x1903
const val GL_RGB8 = 0x8051
const val GL_RGBA8 = 0x8058
const val GL_RGB10_A2 = 0x8059
const val GL_TEXTURE_BINDING_3D = 0x806A
const val GL_UNPACK_SKIP_IMAGES = 0x806D
const val GL_UNPACK_IMAGE_HEIGHT = 0x806E
const val GL_TEXTURE_3D = 0x806F
const val GL_TEXTURE_WRAP_R = 0x8072
const val GL_MAX_3D_TEXTURE_SIZE = 0x8073
const val GL_UNSIGNED_INT_2_10_10_10_REV = 0x8368
const val GL_MAX_ELEMENTS_VERTICES = 0x80E8
const val GL_MAX_ELEMENTS_INDICES = 0x80E9
const val GL_TEXTURE_MIN_LOD = 0x813A
const val GL_TEXTURE_MAX_LOD = 0x813B
const val GL_TEXTURE_BASE_LEVEL = 0x813C
const val GL_TEXTURE_MAX_LEVEL = 0x813D
const val GL_MIN = 0x8007
const val GL_MAX = 0x8008
const val GL_DEPTH_COMPONENT24 = 0x81A6
const val GL_MAX_TEXTURE_LOD_BIAS = 0x84FD
const val GL_TEXTURE_COMPARE_MODE = 0x884C
const val GL_TEXTURE_COMPARE_FUNC = 0x884D
const val GL_CURRENT_QUERY = 0x8865
const val GL_QUERY_RESULT = 0x8866
const val GL_QUERY_RESULT_AVAILABLE = 0x8867
const val GL_BUFFER_MAPPED = 0x88BC
const val GL_BUFFER_MAP_POINTER = 0x88BD
const val GL_STREAM_READ = 0x88E1
const val GL_STREAM_COPY = 0x88E2
const val GL_STATIC_READ = 0x88E5
const val GL_STATIC_COPY = 0x88E6
const val GL_DYNAMIC_READ = 0x88E9
const val GL_DYNAMIC_COPY = 0x88EA
const val GL_MAX_DRAW_BUFFERS = 0x8824
const val GL_DRAW_BUFFER0 = 0x8825
const val GL_DRAW_BUFFER1 = 0x8826
const val GL_DRAW_BUFFER2 = 0x8827
const val GL_DRAW_BUFFER3 = 0x8828
const val GL_DRAW_BUFFER4 = 0x8829
const val GL_DRAW_BUFFER5 = 0x882A
const val GL_DRAW_BUFFER6 = 0x882B
const val GL_DRAW_BUFFER7 = 0x882C
const val GL_DRAW_BUFFER8 = 0x882D
const val GL_DRAW_BUFFER9 = 0x882E
const val GL_DRAW_BUFFER10 = 0x882F
const val GL_DRAW_BUFFER11 = 0x8830
const val GL_DRAW_BUFFER12 = 0x8831
const val GL_DRAW_BUFFER13 = 0x8832
const val GL_DRAW_BUFFER14 = 0x8833
const val GL_DRAW_BUFFER15 = 0x8834
const val GL_MAX_FRAGMENT_UNIFORM_COMPONENTS = 0x8B49
const val GL_MAX_VERTEX_UNIFORM_COMPONENTS = 0x8B4A
const val GL_SAMPLER_3D = 0x8B5F
const val GL_SAMPLER_2D_SHADOW = 0x8B62
const val GL_FRAGMENT_SHADER_DERIVATIVE_HINT = 0x8B8B
const val GL_PIXEL_PACK_BUFFER = 0x88EB
const val GL_PIXEL_UNPACK_BUFFER = 0x88EC
const val GL_PIXEL_PACK_BUFFER_BINDING = 0x88ED
const val GL_PIXEL_UNPACK_BUFFER_BINDING = 0x88EF
const val GL_FLOAT_MAT2x3 = 0x8B65
const val GL_FLOAT_MAT2x4 = 0x8B66
const val GL_FLOAT_MAT3x2 = 0x8B67
const val GL_FLOAT_MAT3x4 = 0x8B68
const val GL_FLOAT_MAT4x2 = 0x8B69
const val GL_FLOAT_MAT4x3 = 0x8B6A
const val GL_SRGB = 0x8C40
const val GL_SRGB8 = 0x8C41
const val GL_SRGB8_ALPHA8 = 0x8C43
const val GL_COMPARE_REF_TO_TEXTURE = 0x884E
const val GL_MAJOR_VERSION = 0x821B
const val GL_MINOR_VERSION = 0x821C
const val GL_NUM_EXTENSIONS = 0x821D
const val GL_RGBA32F = 0x8814
const val GL_RGB32F = 0x8815
const val GL_RGBA16F = 0x881A
const val GL_RGB16F = 0x881B
const val GL_VERTEX_ATTRIB_ARRAY_INTEGER = 0x88FD
const val GL_MAX_ARRAY_TEXTURE_LAYERS = 0x88FF
const val GL_MIN_PROGRAM_TEXEL_OFFSET = 0x8904
const val GL_MAX_PROGRAM_TEXEL_OFFSET = 0x8905
const val GL_MAX_VARYING_COMPONENTS = 0x8B4B
const val GL_TEXTURE_2D_ARRAY = 0x8C1A
const val GL_TEXTURE_BINDING_2D_ARRAY = 0x8C1D
const val GL_R11F_G11F_B10F = 0x8C3A
const val GL_UNSIGNED_INT_10F_11F_11F_REV = 0x8C3B
const val GL_RGB9_E5 = 0x8C3D
const val GL_UNSIGNED_INT_5_9_9_9_REV = 0x8C3E
const val GL_TRANSFORM_FEEDBACK_VARYING_MAX_LENGTH = 0x8C76
const val GL_TRANSFORM_FEEDBACK_BUFFER_MODE = 0x8C7F
const val GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_COMPONENTS = 0x8C80
const val GL_TRANSFORM_FEEDBACK_VARYINGS = 0x8C83
const val GL_TRANSFORM_FEEDBACK_BUFFER_START = 0x8C84
const val GL_TRANSFORM_FEEDBACK_BUFFER_SIZE = 0x8C85
const val GL_TRANSFORM_FEEDBACK_PRIMITIVES_WRITTEN = 0x8C88
const val GL_RASTERIZER_DISCARD = 0x8C89
const val GL_MAX_TRANSFORM_FEEDBACK_INTERLEAVED_COMPONENTS = 0x8C8A
const val GL_MAX_TRANSFORM_FEEDBACK_SEPARATE_ATTRIBS = 0x8C8B
const val GL_INTERLEAVED_ATTRIBS = 0x8C8C
const val GL_SEPARATE_ATTRIBS = 0x8C8D
const val GL_TRANSFORM_FEEDBACK_BUFFER = 0x8C8E
const val GL_TRANSFORM_FEEDBACK_BUFFER_BINDING = 0x8C8F
const val GL_RGBA32UI = 0x8D70
const val GL_RGB32UI = 0x8D71
const val GL_RGBA16UI = 0x8D76
const val GL_RGB16UI = 0x8D77
const val GL_RGBA8UI = 0x8D7C
const val GL_RGB8UI = 0x8D7D
const val GL_RGBA32I = 0x8D82
const val GL_RGB32I = 0x8D83
const val GL_RGBA16I = 0x8D88
const val GL_RGB16I = 0x8D89
const val GL_RGBA8I = 0x8D8E
const val GL_RGB8I = 0x8D8F
const val GL_RED_INTEGER = 0x8D94
const val GL_RGB_INTEGER = 0x8D98
const val GL_RGBA_INTEGER = 0x8D99
const val GL_SAMPLER_2D_ARRAY = 0x8DC1
const val GL_SAMPLER_2D_ARRAY_SHADOW = 0x8DC4
const val GL_SAMPLER_CUBE_SHADOW = 0x8DC5
const val GL_UNSIGNED_INT_VEC2 = 0x8DC6
const val GL_UNSIGNED_INT_VEC3 = 0x8DC7
const val GL_UNSIGNED_INT_VEC4 = 0x8DC8
const val GL_INT_SAMPLER_2D = 0x8DCA
const val GL_INT_SAMPLER_3D = 0x8DCB
const val GL_INT_SAMPLER_CUBE = 0x8DCC
const val GL_INT_SAMPLER_2D_ARRAY = 0x8DCF
const val GL_UNSIGNED_INT_SAMPLER_2D = 0x8DD2
const val GL_UNSIGNED_INT_SAMPLER_3D = 0x8DD3
const val GL_UNSIGNED_INT_SAMPLER_CUBE = 0x8DD4
const val GL_UNSIGNED_INT_SAMPLER_2D_ARRAY = 0x8DD7
const val GL_BUFFER_ACCESS_FLAGS = 0x911F
const val GL_BUFFER_MAP_LENGTH = 0x9120
const val GL_BUFFER_MAP_OFFSET = 0x9121
const val GL_DEPTH_COMPONENT32F = 0x8CAC
const val GL_DEPTH32F_STENCIL8 = 0x8CAD
const val GL_FLOAT_32_UNSIGNED_INT_24_8_REV = 0x8DAD
const val GL_FRAMEBUFFER_ATTACHMENT_COLOR_ENCODING = 0x8210
const val GL_FRAMEBUFFER_ATTACHMENT_COMPONENT_TYPE = 0x8211
const val GL_FRAMEBUFFER_ATTACHMENT_RED_SIZE = 0x8212
const val GL_FRAMEBUFFER_ATTACHMENT_GREEN_SIZE = 0x8213
const val GL_FRAMEBUFFER_ATTACHMENT_BLUE_SIZE = 0x8214
const val GL_FRAMEBUFFER_ATTACHMENT_ALPHA_SIZE = 0x8215
const val GL_FRAMEBUFFER_ATTACHMENT_DEPTH_SIZE = 0x8216
const val GL_FRAMEBUFFER_ATTACHMENT_STENCIL_SIZE = 0x8217
const val GL_FRAMEBUFFER_DEFAULT = 0x8218
const val GL_FRAMEBUFFER_UNDEFINED = 0x8219
const val GL_DEPTH_STENCIL_ATTACHMENT = 0x821A
const val GL_DEPTH_STENCIL = 0x84F9
const val GL_UNSIGNED_INT_24_8 = 0x84FA
const val GL_DEPTH24_STENCIL8 = 0x88F0
const val GL_UNSIGNED_NORMALIZED = 0x8C17
const val GL_READ_FRAMEBUFFER = 0x8CA8
const val GL_DRAW_FRAMEBUFFER = 0x8CA9
const val GL_READ_FRAMEBUFFER_BINDING = 0x8CAA
const val GL_RENDERBUFFER_SAMPLES = 0x8CAB
const val GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LAYER = 0x8CD4
const val GL_MAX_COLOR_ATTACHMENTS = 0x8CDF
const val GL_COLOR_ATTACHMENT1 = 0x8CE1
const val GL_COLOR_ATTACHMENT2 = 0x8CE2
const val GL_COLOR_ATTACHMENT3 = 0x8CE3
const val GL_COLOR_ATTACHMENT4 = 0x8CE4
const val GL_COLOR_ATTACHMENT5 = 0x8CE5
const val GL_COLOR_ATTACHMENT6 = 0x8CE6
const val GL_COLOR_ATTACHMENT7 = 0x8CE7
const val GL_COLOR_ATTACHMENT8 = 0x8CE8
const val GL_COLOR_ATTACHMENT9 = 0x8CE9
const val GL_COLOR_ATTACHMENT10 = 0x8CEA
const val GL_COLOR_ATTACHMENT11 = 0x8CEB
const val GL_COLOR_ATTACHMENT12 = 0x8CEC
const val GL_COLOR_ATTACHMENT13 = 0x8CED
const val GL_COLOR_ATTACHMENT14 = 0x8CEE
const val GL_COLOR_ATTACHMENT15 = 0x8CEF
const val GL_FRAMEBUFFER_INCOMPLETE_MULTISAMPLE = 0x8D56
const val GL_MAX_SAMPLES = 0x8D57
const val GL_HALF_FLOAT = 0x140B
const val GL_MAP_READ_BIT = 0x0001
const val GL_MAP_WRITE_BIT = 0x0002
const val GL_MAP_INVALIDATE_RANGE_BIT = 0x0004
const val GL_MAP_INVALIDATE_BUFFER_BIT = 0x0008
const val GL_MAP_FLUSH_EXPLICIT_BIT = 0x0010
const val GL_MAP_UNSYNCHRONIZED_BIT = 0x0020
const val GL_RG = 0x8227
const val GL_RG_INTEGER = 0x8228
const val GL_R8 = 0x8229
const val GL_RG8 = 0x822B
const val GL_R16F = 0x822D
const val GL_R32F = 0x822E
const val GL_RG16F = 0x822F
const val GL_RG32F = 0x8230
const val GL_R8I = 0x8231
const val GL_R8UI = 0x8232
const val GL_R16I = 0x8233
const val GL_R16UI = 0x8234
const val GL_R32I = 0x8235
const val GL_R32UI = 0x8236
const val GL_RG8I = 0x8237
const val GL_RG8UI = 0x8238
const val GL_RG16I = 0x8239
const val GL_RG16UI = 0x823A
const val GL_RG32I = 0x823B
const val GL_RG32UI = 0x823C
const val GL_VERTEX_ARRAY_BINDING = 0x85B5
const val GL_R8_SNORM = 0x8F94
const val GL_RG8_SNORM = 0x8F95
const val GL_RGB8_SNORM = 0x8F96
const val GL_RGBA8_SNORM = 0x8F97
const val GL_SIGNED_NORMALIZED = 0x8F9C
const val GL_PRIMITIVE_RESTART_FIXED_INDEX = 0x8D69
const val GL_COPY_READ_BUFFER = 0x8F36
const val GL_COPY_WRITE_BUFFER = 0x8F37
const val GL_COPY_READ_BUFFER_BINDING = GL_COPY_READ_BUFFER
const val GL_COPY_WRITE_BUFFER_BINDING = GL_COPY_WRITE_BUFFER
const val GL_UNIFORM_BUFFER = 0x8A11
const val GL_UNIFORM_BUFFER_BINDING = 0x8A28
const val GL_UNIFORM_BUFFER_START = 0x8A29
const val GL_UNIFORM_BUFFER_SIZE = 0x8A2A
const val GL_MAX_VERTEX_UNIFORM_BLOCKS = 0x8A2B
const val GL_MAX_FRAGMENT_UNIFORM_BLOCKS = 0x8A2D
const val GL_MAX_COMBINED_UNIFORM_BLOCKS = 0x8A2E
const val GL_MAX_UNIFORM_BUFFER_BINDINGS = 0x8A2F
const val GL_MAX_UNIFORM_BLOCK_SIZE = 0x8A30
const val GL_MAX_COMBINED_VERTEX_UNIFORM_COMPONENTS = 0x8A31
const val GL_MAX_COMBINED_FRAGMENT_UNIFORM_COMPONENTS = 0x8A33
const val GL_UNIFORM_BUFFER_OFFSET_ALIGNMENT = 0x8A34
const val GL_ACTIVE_UNIFORM_BLOCK_MAX_NAME_LENGTH = 0x8A35
const val GL_ACTIVE_UNIFORM_BLOCKS = 0x8A36
const val GL_UNIFORM_TYPE = 0x8A37
const val GL_UNIFORM_SIZE = 0x8A38
const val GL_UNIFORM_NAME_LENGTH = 0x8A39
const val GL_UNIFORM_BLOCK_INDEX = 0x8A3A
const val GL_UNIFORM_OFFSET = 0x8A3B
const val GL_UNIFORM_ARRAY_STRIDE = 0x8A3C
const val GL_UNIFORM_MATRIX_STRIDE = 0x8A3D
const val GL_UNIFORM_IS_ROW_MAJOR = 0x8A3E
const val GL_UNIFORM_BLOCK_BINDING = 0x8A3F
const val GL_UNIFORM_BLOCK_DATA_SIZE = 0x8A40
const val GL_UNIFORM_BLOCK_NAME_LENGTH = 0x8A41
const val GL_UNIFORM_BLOCK_ACTIVE_UNIFORMS = 0x8A42
const val GL_UNIFORM_BLOCK_ACTIVE_UNIFORM_INDICES = 0x8A43
const val GL_UNIFORM_BLOCK_REFERENCED_BY_VERTEX_SHADER = 0x8A44
const val GL_UNIFORM_BLOCK_REFERENCED_BY_FRAGMENT_SHADER = 0x8A46
// GL_INVALID_INDEX is defined as 0xFFFFFFFFu in C.
const val GL_INVALID_INDEX = -1
const val GL_MAX_VERTEX_OUTPUT_COMPONENTS = 0x9122
const val GL_MAX_FRAGMENT_INPUT_COMPONENTS = 0x9125
const val GL_MAX_SERVER_WAIT_TIMEOUT = 0x9111
const val GL_OBJECT_TYPE = 0x9112
const val GL_SYNC_CONDITION = 0x9113
const val GL_SYNC_STATUS = 0x9114
const val GL_SYNC_FLAGS = 0x9115
const val GL_SYNC_FENCE = 0x9116
const val GL_SYNC_GPU_COMMANDS_COMPLETE = 0x9117
const val GL_UNSIGNALED = 0x9118
const val GL_SIGNALED = 0x9119
const val GL_ALREADY_SIGNALED = 0x911A
const val GL_TIMEOUT_EXPIRED = 0x911B
const val GL_CONDITION_SATISFIED = 0x911C
const val GL_WAIT_FAILED = 0x911D
const val GL_SYNC_FLUSH_COMMANDS_BIT = 0x00000001
// GL_TIMEOUT_IGNORED is defined as 0xFFFFFFFFFFFFFFFFull in C.
const val GL_TIMEOUT_IGNORED: Long = -1
const val GL_VERTEX_ATTRIB_ARRAY_DIVISOR = 0x88FE
const val GL_ANY_SAMPLES_PASSED = 0x8C2F
const val GL_ANY_SAMPLES_PASSED_CONSERVATIVE = 0x8D6A
const val GL_SAMPLER_BINDING = 0x8919
const val GL_RGB10_A2UI = 0x906F
const val GL_TEXTURE_SWIZZLE_R = 0x8E42
const val GL_TEXTURE_SWIZZLE_G = 0x8E43
const val GL_TEXTURE_SWIZZLE_B = 0x8E44
const val GL_TEXTURE_SWIZZLE_A = 0x8E45
const val GL_GREEN = 0x1904
const val GL_BLUE = 0x1905
const val GL_INT_2_10_10_10_REV = 0x8D9F
const val GL_TRANSFORM_FEEDBACK = 0x8E22
const val GL_TRANSFORM_FEEDBACK_PAUSED = 0x8E23
const val GL_TRANSFORM_FEEDBACK_ACTIVE = 0x8E24
const val GL_TRANSFORM_FEEDBACK_BINDING = 0x8E25
const val GL_PROGRAM_BINARY_RETRIEVABLE_HINT = 0x8257
const val GL_PROGRAM_BINARY_LENGTH = 0x8741
const val GL_NUM_PROGRAM_BINARY_FORMATS = 0x87FE
const val GL_PROGRAM_BINARY_FORMATS = 0x87FF
const val GL_COMPRESSED_R11_EAC = 0x9270
const val GL_COMPRESSED_SIGNED_R11_EAC = 0x9271
const val GL_COMPRESSED_RG11_EAC = 0x9272
const val GL_COMPRESSED_SIGNED_RG11_EAC = 0x9273
const val GL_COMPRESSED_RGB8_ETC2 = 0x9274
const val GL_COMPRESSED_SRGB8_ETC2 = 0x9275
const val GL_COMPRESSED_RGB8_PUNCHTHROUGH_ALPHA1_ETC2 = 0x9276
const val GL_COMPRESSED_SRGB8_PUNCHTHROUGH_ALPHA1_ETC2 = 0x9277
const val GL_COMPRESSED_RGBA8_ETC2_EAC = 0x9278
const val GL_COMPRESSED_SRGB8_ALPHA8_ETC2_EAC = 0x9279
const val GL_TEXTURE_IMMUTABLE_FORMAT = 0x912F
const val GL_MAX_ELEMENT_INDEX = 0x8D6B
const val GL_NUM_SAMPLE_COUNTS = 0x9380
const val GL_TEXTURE_IMMUTABLE_LEVELS = 0x82DF

const val GL_ES_VERSION_2_0 = 1
const val GL_DEPTH_BUFFER_BIT = 0x00000100
const val GL_STENCIL_BUFFER_BIT = 0x00000400
const val GL_COLOR_BUFFER_BIT = 0x00004000
const val GL_FALSE = 0
const val GL_TRUE = 1
const val GL_POINTS = 0x0000
const val GL_LINES = 0x0001
const val GL_LINE_LOOP = 0x0002
const val GL_LINE_STRIP = 0x0003
const val GL_TRIANGLES = 0x0004
const val GL_TRIANGLE_STRIP = 0x0005
const val GL_TRIANGLE_FAN = 0x0006
const val GL_ZERO = 0
const val GL_ONE = 1
const val GL_SRC_COLOR = 0x0300
const val GL_ONE_MINUS_SRC_COLOR = 0x0301
const val GL_SRC_ALPHA = 0x0302
const val GL_ONE_MINUS_SRC_ALPHA = 0x0303
const val GL_DST_ALPHA = 0x0304
const val GL_ONE_MINUS_DST_ALPHA = 0x0305
const val GL_DST_COLOR = 0x0306
const val GL_ONE_MINUS_DST_COLOR = 0x0307
const val GL_SRC_ALPHA_SATURATE = 0x0308
const val GL_FUNC_ADD = 0x8006
const val GL_BLEND_EQUATION = 0x8009
const val GL_BLEND_EQUATION_RGB = 0x8009
const val GL_BLEND_EQUATION_ALPHA = 0x883D
const val GL_FUNC_SUBTRACT = 0x800A
const val GL_FUNC_REVERSE_SUBTRACT = 0x800B
const val GL_BLEND_DST_RGB = 0x80C8
const val GL_BLEND_SRC_RGB = 0x80C9
const val GL_BLEND_DST_ALPHA = 0x80CA
const val GL_BLEND_SRC_ALPHA = 0x80CB
const val GL_CONSTANT_COLOR = 0x8001
const val GL_ONE_MINUS_CONSTANT_COLOR = 0x8002
const val GL_CONSTANT_ALPHA = 0x8003
const val GL_ONE_MINUS_CONSTANT_ALPHA = 0x8004
const val GL_BLEND_COLOR = 0x8005
const val GL_ARRAY_BUFFER = 0x8892
const val GL_ELEMENT_ARRAY_BUFFER = 0x8893
const val GL_ARRAY_BUFFER_BINDING = 0x8894
const val GL_ELEMENT_ARRAY_BUFFER_BINDING = 0x8895
const val GL_STREAM_DRAW = 0x88E0
const val GL_STATIC_DRAW = 0x88E4
const val GL_DYNAMIC_DRAW = 0x88E8
const val GL_BUFFER_SIZE = 0x8764
const val GL_BUFFER_USAGE = 0x8765
const val GL_CURRENT_VERTEX_ATTRIB = 0x8626
const val GL_FRONT = 0x0404
const val GL_BACK = 0x0405
const val GL_FRONT_AND_BACK = 0x0408
const val GL_TEXTURE_2D = 0x0DE1
const val GL_CULL_FACE = 0x0B44
const val GL_BLEND = 0x0BE2
const val GL_DITHER = 0x0BD0
const val GL_STENCIL_TEST = 0x0B90
const val GL_DEPTH_TEST = 0x0B71
const val GL_SCISSOR_TEST = 0x0C11
const val GL_POLYGON_OFFSET_FILL = 0x8037
const val GL_SAMPLE_ALPHA_TO_COVERAGE = 0x809E
const val GL_SAMPLE_COVERAGE = 0x80A0
const val GL_NO_ERROR = 0
const val GL_INVALID_ENUM = 0x0500
const val GL_INVALID_VALUE = 0x0501
const val GL_INVALID_OPERATION = 0x0502
const val GL_OUT_OF_MEMORY = 0x0505
const val GL_CW = 0x0900
const val GL_CCW = 0x0901
const val GL_LINE_WIDTH = 0x0B21
const val GL_ALIASED_POINT_SIZE_RANGE = 0x846D
const val GL_ALIASED_LINE_WIDTH_RANGE = 0x846E
const val GL_CULL_FACE_MODE = 0x0B45
const val GL_FRONT_FACE = 0x0B46
const val GL_DEPTH_RANGE = 0x0B70
const val GL_DEPTH_WRITEMASK = 0x0B72
const val GL_DEPTH_CLEAR_VALUE = 0x0B73
const val GL_DEPTH_FUNC = 0x0B74
const val GL_STENCIL_CLEAR_VALUE = 0x0B91
const val GL_STENCIL_FUNC = 0x0B92
const val GL_STENCIL_FAIL = 0x0B94
const val GL_STENCIL_PASS_DEPTH_FAIL = 0x0B95
const val GL_STENCIL_PASS_DEPTH_PASS = 0x0B96
const val GL_STENCIL_REF = 0x0B97
const val GL_STENCIL_VALUE_MASK = 0x0B93
const val GL_STENCIL_WRITEMASK = 0x0B98
const val GL_STENCIL_BACK_FUNC = 0x8800
const val GL_STENCIL_BACK_FAIL = 0x8801
const val GL_STENCIL_BACK_PASS_DEPTH_FAIL = 0x8802
const val GL_STENCIL_BACK_PASS_DEPTH_PASS = 0x8803
const val GL_STENCIL_BACK_REF = 0x8CA3
const val GL_STENCIL_BACK_VALUE_MASK = 0x8CA4
const val GL_STENCIL_BACK_WRITEMASK = 0x8CA5
const val GL_VIEWPORT = 0x0BA2
const val GL_SCISSOR_BOX = 0x0C10
const val GL_COLOR_CLEAR_VALUE = 0x0C22
const val GL_COLOR_WRITEMASK = 0x0C23
const val GL_UNPACK_ALIGNMENT = 0x0CF5
const val GL_PACK_ALIGNMENT = 0x0D05
const val GL_MAX_TEXTURE_SIZE = 0x0D33
const val GL_MAX_TEXTURE_UNITS = 0x84E2
const val GL_MAX_VIEWPORT_DIMS = 0x0D3A
const val GL_SUBPIXEL_BITS = 0x0D50
const val GL_RED_BITS = 0x0D52
const val GL_GREEN_BITS = 0x0D53
const val GL_BLUE_BITS = 0x0D54
const val GL_ALPHA_BITS = 0x0D55
const val GL_DEPTH_BITS = 0x0D56
const val GL_STENCIL_BITS = 0x0D57
const val GL_POLYGON_OFFSET_UNITS = 0x2A00
const val GL_POLYGON_OFFSET_FACTOR = 0x8038
const val GL_TEXTURE_BINDING_2D = 0x8069
const val GL_SAMPLE_BUFFERS = 0x80A8
const val GL_SAMPLES = 0x80A9
const val GL_SAMPLE_COVERAGE_VALUE = 0x80AA
const val GL_SAMPLE_COVERAGE_INVERT = 0x80AB
const val GL_NUM_COMPRESSED_TEXTURE_FORMATS = 0x86A2
const val GL_COMPRESSED_TEXTURE_FORMATS = 0x86A3
const val GL_DONT_CARE = 0x1100
const val GL_FASTEST = 0x1101
const val GL_NICEST = 0x1102
const val GL_GENERATE_MIPMAP = 0x8191
const val GL_GENERATE_MIPMAP_HINT = 0x8192
const val GL_BYTE = 0x1400
const val GL_UNSIGNED_BYTE = 0x1401
const val GL_SHORT = 0x1402
const val GL_UNSIGNED_SHORT = 0x1403
const val GL_INT = 0x1404
const val GL_UNSIGNED_INT = 0x1405
const val GL_FLOAT = 0x1406
const val GL_FIXED = 0x140C
const val GL_DEPTH_COMPONENT = 0x1902
const val GL_ALPHA = 0x1906
const val GL_RGB = 0x1907
const val GL_RGBA = 0x1908
const val GL_LUMINANCE = 0x1909
const val GL_LUMINANCE_ALPHA = 0x190A
const val GL_UNSIGNED_SHORT_4_4_4_4 = 0x8033
const val GL_UNSIGNED_SHORT_5_5_5_1 = 0x8034
const val GL_UNSIGNED_SHORT_5_6_5 = 0x8363
const val GL_FRAGMENT_SHADER = 0x8B30
const val GL_VERTEX_SHADER = 0x8B31
const val GL_MAX_VERTEX_ATTRIBS = 0x8869
const val GL_MAX_VERTEX_UNIFORM_VECTORS = 0x8DFB
const val GL_MAX_VARYING_VECTORS = 0x8DFC
const val GL_MAX_COMBINED_TEXTURE_IMAGE_UNITS = 0x8B4D
const val GL_MAX_VERTEX_TEXTURE_IMAGE_UNITS = 0x8B4C
const val GL_MAX_TEXTURE_IMAGE_UNITS = 0x8872
const val GL_MAX_FRAGMENT_UNIFORM_VECTORS = 0x8DFD
const val GL_SHADER_TYPE = 0x8B4F
const val GL_DELETE_STATUS = 0x8B80
const val GL_LINK_STATUS = 0x8B82
const val GL_VALIDATE_STATUS = 0x8B83
const val GL_ATTACHED_SHADERS = 0x8B85
const val GL_ACTIVE_UNIFORMS = 0x8B86
const val GL_ACTIVE_UNIFORM_MAX_LENGTH = 0x8B87
const val GL_ACTIVE_ATTRIBUTES = 0x8B89
const val GL_ACTIVE_ATTRIBUTE_MAX_LENGTH = 0x8B8A
const val GL_SHADING_LANGUAGE_VERSION = 0x8B8C
const val GL_CURRENT_PROGRAM = 0x8B8D
const val GL_NEVER = 0x0200
const val GL_LESS = 0x0201
const val GL_EQUAL = 0x0202
const val GL_LEQUAL = 0x0203
const val GL_GREATER = 0x0204
const val GL_NOTEQUAL = 0x0205
const val GL_GEQUAL = 0x0206
const val GL_ALWAYS = 0x0207
const val GL_KEEP = 0x1E00
const val GL_REPLACE = 0x1E01
const val GL_INCR = 0x1E02
const val GL_DECR = 0x1E03
const val GL_INVERT = 0x150A
const val GL_INCR_WRAP = 0x8507
const val GL_DECR_WRAP = 0x8508
const val GL_VENDOR = 0x1F00
const val GL_RENDERER = 0x1F01
const val GL_VERSION = 0x1F02
const val GL_EXTENSIONS = 0x1F03
const val GL_NEAREST = 0x2600
const val GL_LINEAR = 0x2601
const val GL_NEAREST_MIPMAP_NEAREST = 0x2700
const val GL_LINEAR_MIPMAP_NEAREST = 0x2701
const val GL_NEAREST_MIPMAP_LINEAR = 0x2702
const val GL_LINEAR_MIPMAP_LINEAR = 0x2703
const val GL_TEXTURE_MAG_FILTER = 0x2800
const val GL_TEXTURE_MIN_FILTER = 0x2801
const val GL_TEXTURE_WRAP_S = 0x2802
const val GL_TEXTURE_WRAP_T = 0x2803
const val GL_TEXTURE = 0x1702
const val GL_TEXTURE_CUBE_MAP = 0x8513
const val GL_TEXTURE_BINDING_CUBE_MAP = 0x8514
const val GL_TEXTURE_CUBE_MAP_POSITIVE_X = 0x8515
const val GL_TEXTURE_CUBE_MAP_NEGATIVE_X = 0x8516
const val GL_TEXTURE_CUBE_MAP_POSITIVE_Y = 0x8517
const val GL_TEXTURE_CUBE_MAP_NEGATIVE_Y = 0x8518
const val GL_TEXTURE_CUBE_MAP_POSITIVE_Z = 0x8519
const val GL_TEXTURE_CUBE_MAP_NEGATIVE_Z = 0x851A
const val GL_MAX_CUBE_MAP_TEXTURE_SIZE = 0x851C
const val GL_TEXTURE0 = 0x84C0
const val GL_TEXTURE1 = 0x84C1
const val GL_TEXTURE2 = 0x84C2
const val GL_TEXTURE3 = 0x84C3
const val GL_TEXTURE4 = 0x84C4
const val GL_TEXTURE5 = 0x84C5
const val GL_TEXTURE6 = 0x84C6
const val GL_TEXTURE7 = 0x84C7
const val GL_TEXTURE8 = 0x84C8
const val GL_TEXTURE9 = 0x84C9
const val GL_TEXTURE10 = 0x84CA
const val GL_TEXTURE11 = 0x84CB
const val GL_TEXTURE12 = 0x84CC
const val GL_TEXTURE13 = 0x84CD
const val GL_TEXTURE14 = 0x84CE
const val GL_TEXTURE15 = 0x84CF
const val GL_TEXTURE16 = 0x84D0
const val GL_TEXTURE17 = 0x84D1
const val GL_TEXTURE18 = 0x84D2
const val GL_TEXTURE19 = 0x84D3
const val GL_TEXTURE20 = 0x84D4
const val GL_TEXTURE21 = 0x84D5
const val GL_TEXTURE22 = 0x84D6
const val GL_TEXTURE23 = 0x84D7
const val GL_TEXTURE24 = 0x84D8
const val GL_TEXTURE25 = 0x84D9
const val GL_TEXTURE26 = 0x84DA
const val GL_TEXTURE27 = 0x84DB
const val GL_TEXTURE28 = 0x84DC
const val GL_TEXTURE29 = 0x84DD
const val GL_TEXTURE30 = 0x84DE
const val GL_TEXTURE31 = 0x84DF
const val GL_ACTIVE_TEXTURE = 0x84E0
const val GL_REPEAT = 0x2901
const val GL_CLAMP_TO_EDGE = 0x812F
const val GL_MIRRORED_REPEAT = 0x8370
const val GL_FLOAT_VEC2 = 0x8B50
const val GL_FLOAT_VEC3 = 0x8B51
const val GL_FLOAT_VEC4 = 0x8B52
const val GL_INT_VEC2 = 0x8B53
const val GL_INT_VEC3 = 0x8B54
const val GL_INT_VEC4 = 0x8B55
const val GL_BOOL = 0x8B56
const val GL_BOOL_VEC2 = 0x8B57
const val GL_BOOL_VEC3 = 0x8B58
const val GL_BOOL_VEC4 = 0x8B59
const val GL_FLOAT_MAT2 = 0x8B5A
const val GL_FLOAT_MAT3 = 0x8B5B
const val GL_FLOAT_MAT4 = 0x8B5C
const val GL_SAMPLER_2D = 0x8B5E
const val GL_SAMPLER_CUBE = 0x8B60
const val GL_VERTEX_ATTRIB_ARRAY_ENABLED = 0x8622
const val GL_VERTEX_ATTRIB_ARRAY_SIZE = 0x8623
const val GL_VERTEX_ATTRIB_ARRAY_STRIDE = 0x8624
const val GL_VERTEX_ATTRIB_ARRAY_TYPE = 0x8625
const val GL_VERTEX_ATTRIB_ARRAY_NORMALIZED = 0x886A
const val GL_VERTEX_ATTRIB_ARRAY_POINTER = 0x8645
const val GL_VERTEX_ATTRIB_ARRAY_BUFFER_BINDING = 0x889F
const val GL_IMPLEMENTATION_COLOR_READ_TYPE = 0x8B9A
const val GL_IMPLEMENTATION_COLOR_READ_FORMAT = 0x8B9B
const val GL_COMPILE_STATUS = 0x8B81
const val GL_INFO_LOG_LENGTH = 0x8B84
const val GL_SHADER_SOURCE_LENGTH = 0x8B88
const val GL_SHADER_COMPILER = 0x8DFA
const val GL_SHADER_BINARY_FORMATS = 0x8DF8
const val GL_NUM_SHADER_BINARY_FORMATS = 0x8DF9
const val GL_LOW_FLOAT = 0x8DF0
const val GL_MEDIUM_FLOAT = 0x8DF1
const val GL_HIGH_FLOAT = 0x8DF2
const val GL_LOW_INT = 0x8DF3
const val GL_MEDIUM_INT = 0x8DF4
const val GL_HIGH_INT = 0x8DF5
const val GL_FRAMEBUFFER = 0x8D40
const val GL_RENDERBUFFER = 0x8D41
const val GL_RGBA4 = 0x8056
const val GL_RGB5_A1 = 0x8057
const val GL_RGB565 = 0x8D62
const val GL_DEPTH_COMPONENT16 = 0x81A5
const val GL_STENCIL_INDEX = 0x1901
const val GL_STENCIL_INDEX8 = 0x8D48
const val GL_RENDERBUFFER_WIDTH = 0x8D42
const val GL_RENDERBUFFER_HEIGHT = 0x8D43
const val GL_RENDERBUFFER_INTERNAL_FORMAT = 0x8D44
const val GL_RENDERBUFFER_RED_SIZE = 0x8D50
const val GL_RENDERBUFFER_GREEN_SIZE = 0x8D51
const val GL_RENDERBUFFER_BLUE_SIZE = 0x8D52
const val GL_RENDERBUFFER_ALPHA_SIZE = 0x8D53
const val GL_RENDERBUFFER_DEPTH_SIZE = 0x8D54
const val GL_RENDERBUFFER_STENCIL_SIZE = 0x8D55
const val GL_FRAMEBUFFER_ATTACHMENT_OBJECT_TYPE = 0x8CD0
const val GL_FRAMEBUFFER_ATTACHMENT_OBJECT_NAME = 0x8CD1
const val GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_LEVEL = 0x8CD2
const val GL_FRAMEBUFFER_ATTACHMENT_TEXTURE_CUBE_MAP_FACE = 0x8CD3
const val GL_COLOR_ATTACHMENT0 = 0x8CE0
const val GL_DEPTH_ATTACHMENT = 0x8D00
const val GL_STENCIL_ATTACHMENT = 0x8D20
const val GL_NONE = 0
const val GL_FRAMEBUFFER_COMPLETE = 0x8CD5
const val GL_FRAMEBUFFER_INCOMPLETE_ATTACHMENT = 0x8CD6
const val GL_FRAMEBUFFER_INCOMPLETE_MISSING_ATTACHMENT = 0x8CD7
const val GL_FRAMEBUFFER_INCOMPLETE_DIMENSIONS = 0x8CD9
const val GL_FRAMEBUFFER_UNSUPPORTED = 0x8CDD
const val GL_FRAMEBUFFER_BINDING = 0x8CA6
const val GL_DRAW_FRAMEBUFFER_BINDING = GL_FRAMEBUFFER_BINDING
const val GL_RENDERBUFFER_BINDING = 0x8CA7
const val GL_MAX_RENDERBUFFER_SIZE = 0x84E8
const val GL_INVALID_FRAMEBUFFER_OPERATION = 0x0506
const val GL_VERTEX_PROGRAM_POINT_SIZE = 0x8642
// Extensions
const val GL_COVERAGE_BUFFER_BIT_NV = 0x8000
const val GL_TEXTURE_MAX_ANISOTROPY_EXT = 0x84FE
const val GL_MAX_TEXTURE_MAX_ANISOTROPY_EXT = 0x84FF